// CSkinWindow Class v1.0 by KrYpT 2006
// Public Domain

IMPORT INT SetWindowRgn(UNSIGNED INT hWnd, INT hRgn, INT bRedraw);
IMPORT INT ExtCreateRegion(INT pXform, INT nCount, POINTER lpRgnData);

Class CSkinWindow
{
	declare SetSkin(CWindow *Handle, STRING RgnPath, STRING PicturePath, INT ImgWidth, INT ImgHeight, INT CloseOnError),INT;
	/* Parameters
	Handle       : Pointer to a CWindow Class Handle.
	RgnPath      : The Path to the Externally generated .rgn file.
	PicturePath  : The Path to an Image file (bmp,jpg,gif).
	ImgWidth     : The Width of the Image file.
	ImgHeight    : The Height of the Image file.
	CloseOnError : True to close the window to skin, False to continue.
	Return       : True if the Skin is Set, False on Error.
	*/
    Cimage img;
}

CSkinWindow::SetSkin(CWindow *Handle, STRING RgnPath, STRING PicturePath, INT ImgWidth, INT ImgHeight, INT CloseOnError),INT
{
	INT RgnFile,RegionSize,Region;
	
	if img.LoadFromFile(PicturePath) <> 0
	{
	    RgnFile = OpenFile(RgnPath ,MODE_READ);
	    if(RgnFile <> 0)
	    {
		    POINTER RegionData;
		    RegionSize = GETFILELENGTH(RgnFile);
		    RegionData = AllocHeap(RegionSize);
			if READ(RgnFile, RegionData, RegionSize) = 0
			{
				Region = ExtCreateRegion(0, RegionSize, RegionData);
				if Region <> 0
				{
					CLOSEFILE(RgnFile);
		            FreeHeap(RegionData);
		            if SetWindowRgn(Handle->m_hWnd, Region, 1) <> 0
					{
				        img.Render(Handle,0,0,ImgWidth,ImgHeight);
						Return True;
					}
					else
					{
						MessageBox(Handle,"Error with SetWindowRgn:"+RgnPath,"Warning!");
			            if CloseOnError = true
			            {
				            Handle->OnClose();
			            }
					    Return False;
					}
				}
				else
				{
					MessageBox(Handle,"Error Creating Skin Region: "+RgnPath,"Warning!");
			        if CloseOnError = true
			        {
				        Handle->OnClose();
			        }
					CLOSEFILE(RgnFile);
		            FreeHeap(RegionData);
					Return False;
				}
			}
			else
			{
				MessageBox(Handle,"Error Reading Skin Region: "+RgnPath,"Warning!");
			    if CloseOnError = true
			    {
				    Handle->OnClose();
			    }
				CLOSEFILE(RgnFile);
		        FreeHeap(RegionData);
				Return False;
			}
	    }
	    else
	    {
		    MessageBox(Handle,"Error loading Skin Region: "+RgnPath,"Warning!");
			if CloseOnError = true
			{
				Handle->OnClose();
			}
			Return False;
	    }
	}
	else
	{
		MessageBox(Handle,"Error loading Skin Picture: "+PicturePath,"Warning!");
		if CloseOnError = true
		{
			Handle->OnClose();
		}
		Return False;
	}
}